"use strict";

// src/index.ts
var import_core = require("@babel/core");
var import_complugin = require("complugin");
var import_lodash = require("lodash");
var compluginBabel = (0, import_complugin.createComplugin)({
  name: "babel",
  enforce: void 0,
  factory(options, meta) {
    let CWD = process.cwd();
    if (meta.framework === "esbuild") {
      CWD = meta.build.initialOptions.absWorkingDir ?? CWD;
    }
    const { include: _include = [/\.(tsx?|jsx?|mjs)$/i], exclude: _exclude, cwd, ..._babelOptions } = options ?? {};
    const babelOptions = {
      ..._babelOptions,
      code: true,
      sourceMaps: true,
      compact: false,
      cwd: cwd ?? CWD
    };
    const getTransformOptions = (0, import_lodash.once)(async () => {
      var _a;
      return (_a = await (0, import_core.loadPartialConfigAsync)(babelOptions)) == null ? void 0 : _a.options;
    });
    return {
      transformInclude: import_complugin.utils.createFilter(_include, _exclude),
      async transform(code, id) {
        const transformOptions = await getTransformOptions();
        const result = await (0, import_core.transformAsync)(code, { ...transformOptions, filename: id });
        if (result) {
          const { code: code2, map } = result;
          if (code2 != null) {
            return { code: code2, map };
          }
        }
      }
    };
  }
});
compluginBabel.default = compluginBabel;
module.exports = compluginBabel;
